<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Messages\MailMessage;
use Illuminate\Notifications\Notification;

class ResetPasswordNotification extends Notification
{
  use Queueable;

  /**
   * Create a new notification instance.
   */
  public function __construct($token)
  {
    try {
      $this->token = $token;
    } catch (\Exception $e) {
      dd('error during preparing password reset email');
    }
  }

  /**
   * Get the notification's delivery channels.
   *
   * @return array<int, string>
   */
  public function via(object $notifiable): array
  {
    return ['mail'];
  }

  /**
   * Get the mail representation of the notification.
   */
  public function toMail($notifiable)
  {
    try {
      return (new MailMessage())
        ->subject('Reset Password Notification')
        ->view('emails.password.reset', [
          'url' => url('reset-password', $this->token),
        ]);
    } catch (\Exception $e) {
      dd($th);
    }
  }

  /**
   * Get the array representation of the notification.
   *
   * @return array<string, mixed>
   */
  public function toArray(object $notifiable): array
  {
    return [
        //
      ];
  }
}
